

/*   
     
    Ec.c Gtk interface     Copyright (C)   2003 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    

   This pgm his derivated from rgbtest.c given has an example in the Gnome documentation
   about Gdk-Pixbuf 
   It is not possible to play with this pgm 
   It is only a draft to manage and print a resisable chess board */ 

#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gnome.h>

#define GDK_PIXBUF_ERROR gdk_pixbuf_error_quark ()


/* Main window */
GtkWidget *app;


/* Visible drawing surface */
GtkWidget *drawing_area;
gint drawing_area_width, drawing_area_height ;
gint square_size;
gint decalage;

/* Double-buffer pixmap */
GdkPixmap *dbuf_pixmap = NULL;

/* Image Elements */
GdkPixbuf *desk_board ;
GdkPixbuf *scaled_desk_board;

GdkPixbuf *white_square,*black_square ;
GdkPixbuf *scaled_white_square,*scaled_black_square ;

GdkPixbuf *white_pawn, *black_pawn;
GdkPixbuf *scaled_white_pawn, *scaled_black_pawn;

GdkPixbuf *white_knight, *black_knight;
GdkPixbuf *scaled_white_knight, *scaled_black_knight;

GdkPixbuf *white_king, *black_king;
GdkPixbuf *scaled_white_king, *scaled_black_king;

GdkPixbuf *white_queen, *black_queen;
GdkPixbuf *scaled_white_queen, *scaled_black_queen;

GdkPixbuf *white_bishop, *black_bishop;
GdkPixbuf *scaled_white_bishop, *scaled_black_bishop;

GdkPixbuf *white_rook, *black_rook;
GdkPixbuf *scaled_white_rook, *scaled_black_rook;

/* board */
struct st_board
{
  GdkPixbuf ** scaled_piece;
  gint draw;
} ts_board [8][8];

/* Directory used for the pixmap */
char *ptc_pixmap_directory=NULL;


/*---------------------------------------------------------------------------------*/
void install_pieces(void)
{
  int x,y;
  for (x=0;x<8;x++)
    for(y=0;y<x;y++)
      {
	ts_board[x][y].scaled_piece=NULL;
	ts_board[x][y].draw=0;
      }
  /*pawn */
  for (x=0;x<8;x++)
    {
 	ts_board[x][1].scaled_piece= &scaled_black_pawn;
 	ts_board[x][1].draw=1;
    }
  for (x=0;x<8;x++)
    {
 	ts_board[x][6].scaled_piece= &scaled_white_pawn;
 	ts_board[x][6].draw=1;
    }
  /* rook */
 	ts_board[0][0].scaled_piece= &scaled_black_rook;
 	ts_board[0][0].draw=1;
 	ts_board[0][7].scaled_piece= &scaled_white_rook;
 	ts_board[0][7].draw=1;

 	ts_board[7][0].scaled_piece= &scaled_black_rook;
 	ts_board[7][0].draw=1;
 	ts_board[7][7].scaled_piece= &scaled_white_rook;
 	ts_board[7][7].draw=1;
 /* knight */
 	ts_board[1][0].scaled_piece= &scaled_black_knight;
 	ts_board[1][0].draw=1;
 	ts_board[1][7].scaled_piece= &scaled_white_knight;
 	ts_board[1][7].draw=1;

 	ts_board[6][0].scaled_piece= &scaled_black_knight;
 	ts_board[6][0].draw=1;
 	ts_board[6][7].scaled_piece= &scaled_white_knight;
 	ts_board[6][7].draw=1;

 /* bishop */
 	ts_board[2][0].scaled_piece= &scaled_black_bishop;
 	ts_board[2][0].draw=1;
 	ts_board[2][7].scaled_piece= &scaled_white_bishop;
 	ts_board[2][7].draw=1;

 	ts_board[5][0].scaled_piece= &scaled_black_bishop;
 	ts_board[5][0].draw=1;
 	ts_board[5][7].scaled_piece= &scaled_white_bishop;
 	ts_board[5][7].draw=1;

 /*queen */
 	ts_board[3][0].scaled_piece= &scaled_black_queen;
 	ts_board[3][0].draw=1;

 	ts_board[3][7].scaled_piece= &scaled_white_queen;
 	ts_board[3][7].draw=1;
 /*king */
 	ts_board[4][0].scaled_piece= &scaled_black_king;
 	ts_board[4][0].draw=1;
 	ts_board[4][7].scaled_piece= &scaled_white_king;
 	ts_board[4][7].draw=1;
}
int chg_pixmap_directory (char * ptc_directory)
{
  if ( ptc_pixmap_directory!=NULL ) free(ptc_pixmap_directory); 
  ptc_pixmap_directory = malloc(strlen(ptc_directory));
  strcpy(ptc_pixmap_directory,ptc_directory);
 
  return 0;
}


int load_file_pixmap(GdkPixbuf **pixmap,char  *ptc_file_name)
{
  char *ptc_file =NULL;
  ptc_file=malloc(strlen(ptc_pixmap_directory)+strlen(ptc_file_name)+1);
  strcpy(ptc_file,ptc_pixmap_directory);
  strcat(ptc_file,ptc_file_name);

 
  *pixmap=gdk_pixbuf_new_from_file(ptc_file);
  
  free (ptc_file);

  if (*pixmap == NULL) return 1;
  else  return 0;
}

int load_pixmaps(void)
{

 /* load desk_board */
  if (load_file_pixmap(&desk_board,"/board_desk.png"))return 1;
 
 /* load square */
  if (load_file_pixmap(&white_square,"/white_square.png"))return 1;
  if (load_file_pixmap(&black_square,"/black_square.png"))return 1;
 
 /* load pawn */
  if (load_file_pixmap(&white_pawn,"/white_pawn.png"))return 1;
  if (load_file_pixmap(&black_pawn,"/black_pawn.png"))return 1;
 
 /* load rook */
  if (load_file_pixmap(&white_rook,"/white_rook.png"))return 1;
  if (load_file_pixmap(&black_rook,"/black_rook.png"))return 1;
 
 /* load knight */
  if (load_file_pixmap(&white_knight,"/white_knight.png"))return 1;
  if (load_file_pixmap(&black_knight,"/black_knight.png"))return 1;
 
 /* load bishop */
  if (load_file_pixmap(&white_bishop,"/white_bishop.png"))return 1;
  if (load_file_pixmap(&black_bishop,"/black_bishop.png"))return 1;
 
 /* load queen */
  if (load_file_pixmap(&white_queen,"/white_queen.png"))return 1;
  if (load_file_pixmap(&black_queen,"/black_queen.png"))return 1;
 
 /* load square */
  if (load_file_pixmap(&white_king,"/white_king.png"))return 1;
  if (load_file_pixmap(&black_king,"/black_king.png"))return 1;
 


 
  return 0;
}
void scale_element (GdkPixbuf **p_scaled_element, GdkPixbuf *element, gint square_size)
{
  if (*p_scaled_element != NULL) g_free(*p_scaled_element);
  *p_scaled_element = gdk_pixbuf_scale_simple(element,square_size,square_size,GDK_INTERP_NEAREST);
  if (*p_scaled_element == NULL) g_message("Scale Null pointer");
 
}
void draw_piece(GdkPixbuf *piece_pixbuf,gint x_square,gint y_square)
{
 
  gdk_pixbuf_render_to_drawable_alpha(piece_pixbuf,
				      dbuf_pixmap,
				      0,0,
				      decalage + x_square * square_size,
				      decalage + y_square *square_size,
				      square_size,
				      square_size,
				      GDK_PIXBUF_ALPHA_BILEVEL,
				      128,
				      GDK_RGB_DITHER_NORMAL,
				      0,0);
 
}
void draw_square(gint x_square,gint y_square)
{
  GdkPixbuf *square_pixbuf;
  if ( (x_square+y_square)%2==0 )
    square_pixbuf=scaled_white_square;
  else
    square_pixbuf=scaled_black_square;

  gdk_pixbuf_render_to_drawable_alpha(square_pixbuf,
				      dbuf_pixmap,
				      0,0,
				      decalage + x_square * square_size,
				      decalage + y_square *square_size,
				      square_size,
				      square_size,
				      GDK_PIXBUF_ALPHA_BILEVEL,
				      128,
				      GDK_RGB_DITHER_NORMAL,
				      0,0);
}

void drawing_area_expose_event(GtkWidget *widget, GdkEventExpose *event,
			       gpointer data)
{
  /* Don't repaint entire window upon each exposure */
  gdk_window_set_back_pixmap (widget->window, NULL, FALSE);

  /* Refresh double buffer, then copy the "dirtied" area to
   * the on-screen GdkWindow
   */
  gdk_window_copy_area(widget->window,
		       widget->style->fg_gc[GTK_STATE_NORMAL],
		       event->area.x, event->area.y,
		       dbuf_pixmap,
		       event->area.x, event->area.y,
		       event->area.width, event->area.height);
}
void draw_chess_board(GtkWidget *drawing_area,gint width,gint height)
{
  gint x,y;
  gint delta;

  /* free the previous pointer on the double buffer */
  if (dbuf_pixmap !=NULL)
    g_free(dbuf_pixmap);
      
  /* allocate a new double_buffer that fit the new drawing area */
  dbuf_pixmap= gdk_pixmap_new(app->window,drawing_area_width,drawing_area_height,-1);

 
  /* size of a square in the drawing area*/
  square_size= (drawing_area_width / 8)-4;
  delta= drawing_area_width - (square_size * 8);
  decalage=delta /2;

  if(square_size !=0)
    {
      /* scale the deskboard pixmap to fit the entire drawing area */
      scale_element(&scaled_desk_board, desk_board,drawing_area_width);

      /* scale all the pixmaps to fit the new drawing size */
      scale_element(&scaled_white_square,white_square,square_size);
      scale_element(&scaled_black_square,black_square,square_size);
 
      scale_element(&scaled_white_pawn,white_pawn,square_size);
      scale_element(&scaled_black_pawn,black_pawn,square_size);
  
      scale_element(&scaled_white_king,white_king,square_size);
      scale_element(&scaled_black_king,black_king,square_size);
  
      scale_element(&scaled_white_queen,white_queen,square_size);
      scale_element(&scaled_black_queen,black_queen,square_size);
  
      scale_element(&scaled_white_bishop,white_bishop,square_size);
      scale_element(&scaled_black_bishop,black_bishop,square_size);
  
      scale_element(&scaled_white_rook,white_rook,square_size);
      scale_element(&scaled_black_rook,black_rook,square_size);
  
      scale_element(&scaled_white_knight,white_knight,square_size);
      scale_element(&scaled_black_knight,black_knight,square_size);
  
     /* draw the desk_board */
      if(scaled_desk_board == NULL) g_message("Sacled desk = NULL");
      gdk_pixbuf_render_to_drawable_alpha(scaled_desk_board,
					  dbuf_pixmap,
					  0,0,
					  0,0,
					  drawing_area_width,
					  drawing_area_height,
					  GDK_PIXBUF_ALPHA_BILEVEL,
					  128,
					  GDK_RGB_DITHER_NORMAL,
					  0,0);
	
      /* draw the chess board */
      for (x=0;x<8;x++)
	{
	  for(y=0;y<8;y++)
	    {
	      /* draw square */
		  draw_square(x,y);
		
	      /* draw the piece */
	      if ( ts_board[x][y].draw==1)
		draw_piece(*(ts_board[x][y].scaled_piece),x,y);
	  
	    }
	  
	}     
    }   
}
void drawing_area_configure_event(GtkWidget *widget, GdkEventConfigure *event,
				  gpointer data)
{
  
  /* Get the drawing_area size */
  drawing_area_width=event->width;
  drawing_area_height=event->height;

  /* create the new dbuf_pixmap */
  draw_chess_board(widget,drawing_area_width,drawing_area_height);

}


gint drawing_area_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gint x,y;
  GdkEventButton *bevent = (GdkEventButton *)event;
  GdkRectangle rect;
  switch ((gint)event->type)
    {
    case GDK_BUTTON_PRESS:
      /* Handle mouse button press and get the coordinates of the square */
      x= (bevent->x-decalage)/square_size;
      y= (bevent->y-decalage)/square_size;

      if(
	 (ts_board[x][y].scaled_piece)==NULL
	 ||
	 bevent->x-decalage <0
	 ||
	 bevent->y-decalage <0
	 ||
	 x<0||x>7||y<0||y>7
	 )
	return TRUE;
      else
	{
	  if (ts_board[x][y].draw==0)
	    {
	      ts_board[x][y].draw=1;
	      draw_piece(*(ts_board[x][y].scaled_piece),x,y);
	    }
	  else
	    {
	      ts_board[x][y].draw=0;
	      draw_square(x,y);
	    }
  
	  rect.x	=		  decalage + x * square_size;
	  rect.y	=		  decalage + y *square_size;
	  rect.width	=		  square_size;
	  rect.height	=		  square_size;
	  gtk_widget_draw(widget, &rect);
	  return TRUE;
	}
     
    }

/* Event not handled; try parent item */
return FALSE;
}

void quit_ec (GtkWidget *widget)
{
  /*  gdk_pixbuf_unref(loader_pixbuf);
      g_free(filebuf);*/
  gtk_main_quit (  );
}

int main (int argc, char **argv)
{
  GtkWidget *vbox;
  GtkWidget *label;
  GtkWidget *board_frame;
  GdkPixbuf *pixbuf;
  
  /* Includes a call to gdk_rgb_init(  ) */
  gtk_init(&argc, &argv);
  if (argv[1]!=NULL)
    chg_pixmap_directory(argv[1]);
  else
    chg_pixmap_directory("blue_pixmap");
    

   /* Load Pixmap */
  if (load_pixmaps()) 
    {
      g_message("Error loading pixmap");
      return 1;
    }
  /* install pieces on the board */
  install_pieces();

   /* create application window */
  gtk_widget_push_visual(gdk_rgb_get_visual(  ));
  gtk_widget_push_colormap(gdk_rgb_get_cmap(  ));
  app = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_pop_visual(  );
  gtk_widget_pop_colormap(  );

  /*  */
  gtk_widget_set_usize(app,200,200);
  gtk_window_set_policy(GTK_WINDOW(app), TRUE, TRUE, FALSE);

  /* Handle window manager closing */
  gtk_signal_connect(GTK_OBJECT(app), "delete_event",
    GTK_SIGNAL_FUNC(quit_ec), NULL);
  
  /* Create vertical box  and add in the application  window */
  vbox= gtk_vbox_new(FALSE,10);
  gtk_container_add(GTK_CONTAINER(app), vbox);

  /* Add a label  in the top of the vbox */
  /* do not expand and fill, padding = 10*/
  label = gtk_label_new("Just to put something");
  gtk_box_pack_start(GTK_BOX(vbox),GTK_WIDGET(label),FALSE,FALSE,10);

  /* Add an aspect frame in the  vbox */
  /* centered, squared, ignore child size */
  board_frame= gtk_aspect_frame_new(NULL,0.5,0.5,1,FALSE);
  gtk_frame_set_shadow_type (GTK_FRAME(board_frame),GTK_SHADOW_NONE);


  gtk_box_pack_start(GTK_BOX(vbox),GTK_WIDGET(board_frame),TRUE,TRUE,10);


  /* Add the  board drawing-area in the aspect  frame  */
  drawing_area = gtk_drawing_area_new (  );
  gtk_widget_add_events(GTK_WIDGET(drawing_area),
    GDK_BUTTON_PRESS_MASK);
  gtk_signal_connect(GTK_OBJECT(drawing_area), "expose_event",
    GTK_SIGNAL_FUNC(drawing_area_expose_event), NULL);
  gtk_signal_connect(GTK_OBJECT(drawing_area), "event",
    GTK_SIGNAL_FUNC(drawing_area_event), NULL);
  gtk_signal_connect(GTK_OBJECT(drawing_area), "configure_event",
    GTK_SIGNAL_FUNC(drawing_area_configure_event), NULL);


  gtk_container_add(GTK_CONTAINER(board_frame), drawing_area);

  gtk_widget_show_all(app);

  gtk_main (  );

  return 0;
}
        
